package com.steerinfo.inPlantNavigation.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="地图导航中顶点的边")
public class MapVertexEdge implements IBasePO<BigDecimal> {
    /**
     * 边ID(VERTEXEDGE_ID,DECIMAL,10)
     */
    @ApiModelProperty(value="边ID",required=true)
    private BigDecimal vertexedgeId;

    /**
     * 起始点，出点(OUTVERTEX_ID,DECIMAL,10)
     */
    @ApiModelProperty(value="起始点，出点",required=false)
    private BigDecimal outvertexId;

    /**
     * 终点，入点(INVERTEX_ID,DECIMAL,10)
     */
    @ApiModelProperty(value="终点，入点",required=false)
    private BigDecimal invertexId;

    /**
     * 权重(WEIGH,DECIMAL,38)
     */
    @ApiModelProperty(value="权重",required=false)
    private BigDecimal weigh;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.vertexedgeId;
    }

    @Override
    public void setId(BigDecimal vertexedgeId) {
        this.vertexedgeId = vertexedgeId;
    }

    public BigDecimal getVertexedgeId() {
        return vertexedgeId;
    }

    public void setVertexedgeId(BigDecimal vertexedgeId) {
        this.vertexedgeId = vertexedgeId;
    }

    public BigDecimal getOutvertexId() {
        return outvertexId;
    }

    public void setOutvertexId(BigDecimal outvertexId) {
        this.outvertexId = outvertexId;
    }

    public BigDecimal getInvertexId() {
        return invertexId;
    }

    public void setInvertexId(BigDecimal invertexId) {
        this.invertexId = invertexId;
    }

    public BigDecimal getWeigh() {
        return weigh;
    }

    public void setWeigh(BigDecimal weigh) {
        this.weigh = weigh;
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", vertexedgeId=").append(vertexedgeId);
        sb.append(", outvertexId=").append(outvertexId);
        sb.append(", invertexId=").append(invertexId);
        sb.append(", weigh=").append(weigh);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}